import java.awt.Component;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

/**
 * 
 */

class ArrowListRenderer
	extends JLabel
	implements ListCellRenderer
{
	private String[] textImage;
	private ImageIcon[] images;

	public ArrowListRenderer(int index)
	{
		textImage = new String[index];
		images = new ImageIcon[index];

		setOpaque(true);
		setHorizontalAlignment(CENTER);
        setVerticalAlignment(CENTER);
	}

	public void createArrowImage(int index, String textImage, ImageIcon image)
	{
		this.textImage[index] = textImage;
		this.images[index] = image;
	}

	/*
     * This method finds the image and text corresponding
     * to the selected value and returns the label, set up
     * to display the text and image.
     */
     public Component getListCellRendererComponent(JList list, Object value,
    	 int index, boolean isSelected, boolean cellHasFocus)
     {
    	//Get the selected index. (The index param isn't
     	//always valid, so just use the value.)
		int selectedIndex = ((Integer)value).intValue();

		if (isSelected)
		{
        	 setBackground(list.getSelectionBackground());
    	     setForeground(list.getSelectionForeground());
        }
		else
		{
     	     setBackground(list.getBackground());
             setForeground(list.getForeground());
        }

        setText(textImage[selectedIndex ]);
        return this;
	}
}