

package com.mindfusion.diagramming.samples.demo;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;


public class AboutDialog extends JDialog
{
	/**
	 * Initializes a new instance of the TourDialog class with
	 * the specified parent. The dialog is centered within
	 * the parent.
	 */
	public AboutDialog(JFrame parent)
	{
		super(parent, true);

		setTitle("About MindFusion JDiagram Demo");
		setSize(360, 184);
		setResizable(false);

		// Center in parent
		Rectangle parentBounds = new Rectangle();
		parent.getBounds(parentBounds);

		setLocation((parentBounds.width - getWidth()) / 2,
			(parentBounds.height - getHeight()) / 2);

		// Initialize frame
		initializeComponent();
	}

	/**
	 * Initializes child controls.
	 */
	private void initializeComponent()
	{
		setLayout(null);

		//
		// _image
		//
		_image = new JLabel();
		_image.setIcon(getIcon());
		_image.setLocation(16, 22);
		_image.setSize(34, 34);
		_image.setBorder(new LineBorder(SystemColor.windowBorder, 1));

		//
		// _label1
		//
		_label1 = new JLabel();
		_label1.setText("JDiagram Demo Program");
		_label1.setLocation(58, 18);
		_label1.setSize(290, 22);

		//
		// _label2
		//
		_label2 = new JLabel();
		_label2.setText("Copyright (C) 2003-2012, MindFusion LLC");
		_label2.setLocation(58, 36);
		_label2.setSize(290, 22);

		//
		// _label3
		//
		_label3 = new JLabel();
		_label3.setText("<html>Visit our web-site at: <u>http://www.mindfusion.eu/</u></html>");
		_label3.setLocation(16, 76);
		_label3.setSize(332, 22);

		//
		// _btnClose
		//
		_btnClose = new JButton();
		_btnClose.setText("Close");
		_btnClose.setLocation(278, 120);
		_btnClose.setSize(68, 22);
		_btnClose.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					AboutDialog.this.onBtnClose(e);
				}
			}
		);

		Container contents = getContentPane();

		contents.add(_image);
		contents.add(_label1);
		contents.add(_label2);
		contents.add(_label3);
		contents.add(_btnClose);
	}

	/**
	 * Handles the Close button click.
	 */
	private void onBtnClose(ActionEvent e)
	{
		hide();
	}

	private ImageIcon getIcon()
	{
		java.net.URL imageURL = AboutDialog.class.getResource("Files//NetIco.gif");
		if (imageURL != null)
		    return new ImageIcon(imageURL);

		return null;
	}


	private JLabel _image;
	private JLabel _label1;
	private JLabel _label2;
	private JLabel _label3;
	private JButton _btnClose;
}
