
package com.mindfusion.diagramming.samples.demo;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

import com.mindfusion.diagramming.*;


public class ClassInfoDialog extends JDialog
{
	/**
	 * Initializes a new instance of the ClassInfoDialog class with
	 * the specified parent. The dialog is centered within
	 * the parent.
	 */
	public ClassInfoDialog(JFrame parent)
	{
		super(parent, true);

		_accepted = false;
		_cycleProtect = false;

		setTitle("Class Information");
		setSize(450, 400);
		setResizable(false);

		// Center in parent
		Rectangle parentBounds = new Rectangle();
		parent.getBounds(parentBounds);

		setLocation((parentBounds.width - getWidth()) / 2,
			(parentBounds.height - getHeight()) / 2);

		// Initialize frame
		initializeComponent();
	}

	/**
	 * Initializes child controls.
	 */
	private void initializeComponent()
	{
		setLayout(null);

		//
		// _lblName
		//
		_lblName = new JLabel();
		_lblName.setText("Name");
		_lblName.setLocation(7, 20);
		_lblName.setSize(46, 14);

		//
		// _txtName
		//
		_txtName = new JTextField();
		_txtName.setLocation(62, 17);
		_txtName.setSize(154, 20);

		//
		// _lblBaseClasses
		//
		_lblBaseClasses = new JLabel();
		_lblBaseClasses.setText("Base classes:");
		_lblBaseClasses.setLocation(7, 51);
		_lblBaseClasses.setSize(112, 14);

		//
		// _lstBaseClasses
		//
		_lstBaseClasses = new JList();
		_lstBaseClasses.setModel(new DefaultListModel());
		_lstBaseClasses.setLocation(7, 72);
		_lstBaseClasses.setSize(209, 82);
		_lstBaseClasses.setBorder(new EtchedBorder(SystemColor.controlHighlight, SystemColor.controlShadow));

		//
		// _lblDerivedClasses
		//
		_lblDerivedClasses = new JLabel();
		_lblDerivedClasses.setText("Derived classes:");
		_lblDerivedClasses.setLocation(224, 51);
		_lblDerivedClasses.setSize(113, 16);

		//
		// _lstDerivedClasses
		//
		_lstDerivedClasses = new JList();
		_lstDerivedClasses.setModel(new DefaultListModel());
		_lstDerivedClasses.setLocation(224, 72);
		_lstDerivedClasses.setSize(208, 82);
		_lstDerivedClasses.setBorder(new EtchedBorder(SystemColor.controlHighlight, SystemColor.controlShadow));

		//
		// _lblMethods
		//
		_lblMethods = new JLabel();
		_lblMethods.setText("Methods:");
		_lblMethods.setLocation(7, 168);
		_lblMethods.setSize(209, 14);

		//
		// _lstMethods
		//
		_lstMethods = new JList();
		_lstMethods.setModel(new DefaultListModel());
		_lstMethods.setLocation(7, 192);
		_lstMethods.setSize(185, 98);
		_lstMethods.setBorder(new EtchedBorder(SystemColor.controlHighlight, SystemColor.controlShadow));
		_lstMethods.addListSelectionListener
		(
			new ListSelectionListener()
			{
				public void valueChanged(ListSelectionEvent e)
				{
					ClassInfoDialog.this.onSelectedMethodChanged(e);
				}
			}
		);

		//
		// _btnAddMethod
		//
		_btnAddMethod = new JButton();
		_btnAddMethod.setIcon(getIcon("Files/plus.gif"));
		_btnAddMethod.setHorizontalAlignment(SwingConstants.CENTER);
		_btnAddMethod.setVerticalAlignment(SwingConstants.CENTER);
		_btnAddMethod.setToolTipText("Add Method");
		_btnAddMethod.setLocation(192, 192);
		_btnAddMethod.setSize(24, 24);
		_btnAddMethod.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					ClassInfoDialog.this.onBtnAddMethod(e);
				}
			}
		);

		//
		// _btnDelMethod
		//
		_btnDelMethod = new JButton();
		_btnDelMethod.setIcon(getIcon("Files/del.gif"));
		_btnDelMethod.setHorizontalAlignment(SwingConstants.CENTER);
		_btnDelMethod.setVerticalAlignment(SwingConstants.CENTER);
		_btnDelMethod.setToolTipText("Delete Method");
		_btnDelMethod.setLocation(192, 216);
		_btnDelMethod.setSize(24, 24);
		_btnDelMethod.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					ClassInfoDialog.this.onBtnDelMethod(e);
				}
			}
		);

		//
		// _btnUpMethod
		//
		_btnUpMethod = new JButton();
		_btnUpMethod.setIcon(getIcon("Files/up.gif"));
		_btnUpMethod.setHorizontalAlignment(SwingConstants.CENTER);
		_btnUpMethod.setVerticalAlignment(SwingConstants.CENTER);
		_btnUpMethod.setToolTipText("Move Up");
		_btnUpMethod.setLocation(192, 240);
		_btnUpMethod.setSize(24, 24);
		_btnUpMethod.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					ClassInfoDialog.this.onBtnUpMethod(e);
				}
			}
		);

		//
		// _btnDownMethod
		//
		_btnDownMethod = new JButton();
		_btnDownMethod.setIcon(getIcon("Files/down.gif"));
		_btnDownMethod.setHorizontalAlignment(SwingConstants.CENTER);
		_btnDownMethod.setVerticalAlignment(SwingConstants.CENTER);
		_btnDownMethod.setToolTipText("Move Down");
		_btnDownMethod.setLocation(192, 264);
		_btnDownMethod.setSize(24, 24);
		_btnDownMethod.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					ClassInfoDialog.this.onBtnDownMethod(e);
				}
			}
		);

		//
		// _txtMethod
		//
		_txtMethod = new JTextField();
		_txtMethod.setLocation(7, 296);
		_txtMethod.setSize(209, 20);
		_txtMethod.addKeyListener
		(
			new KeyAdapter()
			{
				public void keyReleased(KeyEvent e)
				{
					ClassInfoDialog.this.onMethodChanged(e);
				}
			}
		);

		//
		// _lblProperties
		//
		_lblProperties = new JLabel();
		_lblProperties.setText("Properties:");
		_lblProperties.setLocation(224, 168);
		_lblProperties.setSize(208, 14);

		//
		// _lstProperties
		//
		_lstProperties = new JList();
		_lstProperties.setModel(new DefaultListModel());
		_lstProperties.setLocation(224, 192);
		_lstProperties.setSize(184, 98);
		_lstProperties.setBorder(new EtchedBorder(SystemColor.controlHighlight, SystemColor.controlShadow));
		_lstProperties.addListSelectionListener
		(
			new ListSelectionListener()
			{
				public void valueChanged(ListSelectionEvent e)
				{
					ClassInfoDialog.this.onSelectedPropertyChanged(e);
				}
			}
		);

		//
		// _btnAddProperty
		//
		_btnAddProperty = new JButton();
		_btnAddProperty.setIcon(getIcon("Files/plus.gif"));
		_btnAddProperty.setHorizontalAlignment(SwingConstants.CENTER);
		_btnAddProperty.setVerticalAlignment(SwingConstants.CENTER);
		_btnAddProperty.setToolTipText("Add Property");
		_btnAddProperty.setLocation(408, 192);
		_btnAddProperty.setSize(24, 24);
		_btnAddProperty.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					ClassInfoDialog.this.onBtnAddProperty(e);
				}
			}
		);

		//
		// _btnDelProperty
		//
		_btnDelProperty = new JButton();
		_btnDelProperty.setIcon(getIcon("Files/del.gif"));
		_btnDelProperty.setHorizontalAlignment(SwingConstants.CENTER);
		_btnDelProperty.setVerticalAlignment(SwingConstants.CENTER);
		_btnDelProperty.setToolTipText("Delete Property");
		_btnDelProperty.setLocation(408, 216);
		_btnDelProperty.setSize(24, 24);
		_btnDelProperty.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					ClassInfoDialog.this.onBtnDelProperty(e);
				}
			}
		);

		//
		// _btnUpProperty
		//
		_btnUpProperty = new JButton();
		_btnUpProperty.setIcon(getIcon("Files/up.gif"));
		_btnUpProperty.setHorizontalAlignment(SwingConstants.CENTER);
		_btnUpProperty.setVerticalAlignment(SwingConstants.CENTER);
		_btnUpProperty.setToolTipText("Move Up");
		_btnUpProperty.setLocation(408, 240);
		_btnUpProperty.setSize(24, 24);
		_btnUpProperty.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					ClassInfoDialog.this.onBtnUpProperty(e);
				}
			}
		);

		//
		// _btnDownProperty
		//
		_btnDownProperty = new JButton();
		_btnDownProperty.setIcon(getIcon("Files/down.gif"));
		_btnDownProperty.setHorizontalAlignment(SwingConstants.CENTER);
		_btnDownProperty.setVerticalAlignment(SwingConstants.CENTER);
		_btnDownProperty.setToolTipText("Move Down");
		_btnDownProperty.setLocation(408, 264);
		_btnDownProperty.setSize(24, 24);
		_btnDownProperty.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					ClassInfoDialog.this.onBtnDownProperty(e);
				}
			}
		);

		//
		// _txtProperty
		//
		_txtProperty = new JTextField();
		_txtProperty.setLocation(224, 296);
		_txtProperty.setSize(209, 20);
		_txtProperty.addKeyListener
		(
			new KeyAdapter()
			{
				public void keyReleased(KeyEvent e)
				{
					ClassInfoDialog.this.onPropertyChanged(e);
				}
			}
		);

		//
		// _btnOk
		//
		_btnOk = new JButton();
		_btnOk.setText("OK");
		_btnOk.setLocation(140, 344);
		_btnOk.setSize(80, 20);
		_btnOk.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					ClassInfoDialog.this.onBtnOk(e);
				}
			}
		);

		//
		// _btnCancel
		//
		_btnCancel = new JButton();
		_btnCancel.setText("Cancel");
		_btnCancel.setLocation(230, 344);
		_btnCancel.setSize(80, 20);
		_btnCancel.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					ClassInfoDialog.this.onBtnCancel(e);
				}
			}
		);

		Container contents = getContentPane();

		contents.add(_lblName);
		contents.add(_txtName);
		contents.add(_lblBaseClasses);
		contents.add(_lstBaseClasses);
		contents.add(_lblDerivedClasses);
		contents.add(_lstDerivedClasses);
		contents.add(_lblMethods);
		contents.add(_lstMethods);
		contents.add(_btnAddMethod);
		contents.add(_btnDelMethod);
		contents.add(_btnUpMethod);
		contents.add(_btnDownMethod);
		contents.add(_txtMethod);
		contents.add(_lblProperties);
		contents.add(_lstProperties);
		contents.add(_btnAddProperty);
		contents.add(_btnDelProperty);
		contents.add(_btnUpProperty);
		contents.add(_btnDownProperty);
		contents.add(_txtProperty);
		contents.add(_btnOk);
		contents.add(_btnCancel);
	}

	/**
	 * Handles the 'OK' button click.
	 */
	private void onBtnOk(ActionEvent e)
	{
		// Save changes
		if (_editedClass != null)
		{
			_editedClass.setCaption(_txtName.getText());

			int rows = _lstMethods.getModel().getSize() +
				_lstProperties.getModel().getSize() + 2;
			int index = 0;

			_editedClass.redimTable(0, 0);
			_editedClass.redimTable(2, rows);

			_editedClass.getCell(0, index).setColumnSpan(2);
			_editedClass.getCell(0, index).setText("<b>Methods</b>");
			_editedClass.getRows().get(index).setHeader(true);
			index++;

			_editedClass.getColumns().get(0).setWidth(_editedClass.getRowHeight());

			for (int i = 0; i < _lstMethods.getModel().getSize(); i++)
			{
				String method = (String)_lstMethods.getModel().getElementAt(i);

				_editedClass.getCell(0, index).setImageAlign(ImageAlign.Center);
				_editedClass.getCell(1, index).setText(method);

				index++;
			}

			_editedClass.getCell(0, index).setColumnSpan(2);
			_editedClass.getCell(0, index).setText("<b>Properties</b>");
			_editedClass.getRows().get(index).setHeader(true);
			index++;

			for (int i = 0; i < _lstProperties.getModel().getSize(); i++)
			{
				String property = (String)_lstProperties.getModel().getElementAt(i);

				_editedClass.getCell(0, index).setImageAlign(ImageAlign.Center);
				_editedClass.getCell(1, index).setText(property);

				index++;
			}
		}

		_accepted = true;

		hide();
	}

	/**
	 * Handles the 'Cancel' button click.
	 */
	private void onBtnCancel(ActionEvent e)
	{
		_accepted = false;

		hide();
	}

	/**
	 * Gets the image with the specified name.
	 */
	private ImageIcon getIcon(String fileName)
	{
		java.net.URL imageURL = ClassInfoDialog.class.getResource(fileName);
		if (imageURL != null)
		    return new ImageIcon(imageURL);

		return null;
	}

	/**
	 * Sets the table, representing the edited class.
	 */
	public void setEditedClass(TableNode value)
	{
		_editedClass = value;

		// Fill the info
		_txtName.setText(_editedClass.getCaption());

		DiagramLinkList inc = _editedClass.getIncomingLinks();
		if (inc != null)
		{
			DefaultListModel model = (DefaultListModel)_lstBaseClasses.getModel();

			for (DiagramLink a : inc)
			{
				if (a.getOrigin() instanceof TableNode)
					model.addElement(((TableNode)a.getOrigin()).getCaption());
			}
		}

		DiagramLinkList outg = _editedClass.getOutgoingLinks();
		if (outg != null)
		{
			DefaultListModel model = (DefaultListModel)_lstDerivedClasses.getModel();

			for (DiagramLink a : outg)
			{
				if (a.getDestination() instanceof TableNode)
					model.addElement(((TableNode)a.getDestination()).getCaption());
			}
		}

		int header = 0;
		for (int i = 0; i < _editedClass.getRowCount(); i++)
		{
			if (_editedClass.getRows().get(i).getHeader())
			{
				header++;
				continue;
			}

			if (header == 1)
			{
				DefaultListModel model = (DefaultListModel)_lstMethods.getModel();
				model.addElement(_editedClass.getCell(1, i).getText());
			}
			else
			{
				DefaultListModel model = (DefaultListModel)_lstProperties.getModel();
				model.addElement(_editedClass.getCell(1, i).getText());
			}
		}

		if (_lstMethods.getModel().getSize() > 0)
		{
			_lstMethods.setSelectedIndex(0);
			_txtMethod.setText((String)_lstMethods.getModel().getElementAt(0));
		}

		if (_lstProperties.getModel().getSize() > 0)
		{
			_lstProperties.setSelectedIndex(0);
			_txtProperty.setText((String)_lstProperties.getModel().getElementAt(0));
		}
	}

	/**
	 * Handles selection changes in the property list.
	 */
	private void onSelectedMethodChanged(ListSelectionEvent e)
	{
		updateSelectedMethodText();
	}

	/**
	 * Updates the method text in the text field below the list
	 * from the current selection in the list.
	 */
	private void updateSelectedMethodText()
	{
		if (_cycleProtect)
			return;

		_cycleProtect = true;

		if (_lstMethods.getSelectedIndex() < 0)
			_txtMethod.setText("");
		else
			_txtMethod.setText((String)_lstMethods.getSelectedValue());

		_cycleProtect = false;
	}

	/**
	 * Handles selection changes in the property list.
	 */
	private void onSelectedPropertyChanged(ListSelectionEvent e)
	{
		updateSelectedPropertyText();
	}

	/**
	 * Updates the method text in the text field below the list
	 * from the current selection in the list.
	 */
	private void updateSelectedPropertyText()
	{
		if (_cycleProtect)
			return;

		_cycleProtect = true;

		if (_lstProperties.getSelectedIndex() < 0)
			_txtProperty.setText("");
		else
			_txtProperty.setText((String)_lstProperties.getSelectedValue());

		_cycleProtect = false;
	}

	/**
	 * Handles the 'Add method' button click.
	 */
	private void onBtnAddMethod(ActionEvent e)
	{
		DefaultListModel model = (DefaultListModel)_lstMethods.getModel();
		model.addElement("method(...)");
		_lstMethods.setSelectedIndex(model.size() - 1);
	}

	/**
	 * Handles the 'Del method' button click.
	 */
	private void onBtnDelMethod(ActionEvent e)
	{
		int index = _lstMethods.getSelectedIndex();
		if (index >= 0)
		{
			DefaultListModel model = (DefaultListModel)_lstMethods.getModel();

			model.remove(index);

			if (index < model.getSize())
				_lstMethods.setSelectedIndex(index);

			updateSelectedMethodText();
		}
	}

	/**
	 * Handles the 'Up method' button click.
	 */
	private void onBtnUpMethod(ActionEvent e)
	{
		DefaultListModel model = (DefaultListModel)_lstMethods.getModel();
		int index = _lstMethods.getSelectedIndex();
		if (index > 0)
		{
			Object temp = model.get(index);
			model.set(index, model.get(index - 1));
			model.set(index - 1, temp);

			_lstMethods.setSelectedIndex(_lstMethods.getSelectedIndex() - 1);
		}
	}

	/**
	 * Handles the 'Del method' button click.
	 */
	private void onBtnDownMethod(ActionEvent e)
	{
		DefaultListModel model = (DefaultListModel)_lstMethods.getModel();
		int index = _lstMethods.getSelectedIndex();
		if (index < model.getSize() - 1)
		{
			Object temp = model.get(index);
			model.set(index, model.get(index + 1));
			model.set(index + 1, temp);

			_lstMethods.setSelectedIndex(_lstMethods.getSelectedIndex() + 1);
		}
	}

	/**
	 * Handles the 'Add property' button click.
	 */
	private void onBtnAddProperty(ActionEvent e)
	{
		DefaultListModel model = (DefaultListModel)_lstProperties.getModel();
		model.addElement("property");
		_lstProperties.setSelectedIndex(model.size() - 1);
	}

	/**
	 * Handles the 'Del property' button click.
	 */
	private void onBtnDelProperty(ActionEvent e)
	{
		int index = _lstProperties.getSelectedIndex();
		if (index >= 0)
		{
			DefaultListModel model = (DefaultListModel)_lstProperties.getModel();

			model.remove(index);

			if (index < model.getSize())
				_lstProperties.setSelectedIndex(index);

			updateSelectedPropertyText();
		}
	}

	/**
	 * Handles the 'Up property' button click.
	 */
	private void onBtnUpProperty(ActionEvent e)
	{
		DefaultListModel model = (DefaultListModel)_lstProperties.getModel();
		int index = _lstProperties.getSelectedIndex();
		if (index > 0)
		{
			Object temp = model.get(index);
			model.set(index, model.get(index - 1));
			model.set(index - 1, temp);

			_lstProperties.setSelectedIndex(_lstProperties.getSelectedIndex() - 1);
		}
	}

	/**
	 * Handles the 'Del property' button click.
	 */
	private void onBtnDownProperty(ActionEvent e)
	{
		DefaultListModel model = (DefaultListModel)_lstProperties.getModel();
		int index = _lstProperties.getSelectedIndex();
		if (index < model.getSize() - 1)
		{
			Object temp = model.get(index);
			model.set(index, model.get(index + 1));
			model.set(index + 1, temp);

			_lstProperties.setSelectedIndex(_lstProperties.getSelectedIndex() + 1);
		}
	}

	/**
	 * Handles changes in the declaration of the current method.
	 */
	private void onMethodChanged(KeyEvent e)
	{
		if (_cycleProtect)
			return;

		if (_lstMethods.getSelectedIndex() < 0)
			return;

		_cycleProtect = true;
		DefaultListModel model = (DefaultListModel)_lstMethods.getModel();
		model.set(_lstMethods.getSelectedIndex(), _txtMethod.getText());
		_cycleProtect = false;
	}

	/**
	 * Handles changes in the declaration of the current property.
	 */
	private void onPropertyChanged(KeyEvent e)
	{
		if (_cycleProtect)
			return;

		if (_lstProperties.getSelectedIndex() < 0)
			return;

		_cycleProtect = true;
		DefaultListModel model = (DefaultListModel)_lstProperties.getModel();
		model.set(_lstProperties.getSelectedIndex(), _txtProperty.getText());
		_cycleProtect = false;
	}

	/**
	 * Gets whether the user has confirmed the dialog.
	 */
	public boolean getAccepted() { return _accepted; }


	private boolean _accepted;

	private boolean _cycleProtect;

	private JLabel _lblName;
	private JTextField _txtName;
	private JLabel _lblBaseClasses;
	private JList _lstBaseClasses;
	private JLabel _lblDerivedClasses;
	private JList _lstDerivedClasses;
	private JLabel _lblMethods;
	private JList _lstMethods;
	private JButton _btnAddMethod;
	private JButton _btnDelMethod;
	private JButton _btnUpMethod;
	private JButton _btnDownMethod;
	private JTextField _txtMethod;
	private JLabel _lblProperties;
	private JList _lstProperties;
	private JButton _btnAddProperty;
	private JButton _btnDelProperty;
	private JButton _btnUpProperty;
	private JButton _btnDownProperty;
	private JTextField _txtProperty;

	private JButton _btnOk;
	private JButton _btnCancel;

	private TableNode _editedClass;
}
